﻿using System;
using System.Linq;
using System.Collections.ObjectModel;
using System.Net;
using System.IO;
using System.Threading.Tasks;
using System.Xml;
using System.ServiceModel.Syndication;
using System.Windows.Media.Imaging;

namespace Async.Workers
{
	class TheNewWay : IDoWork
	{
		private static readonly Uri FlickrRss = new Uri("http://api.flickr.com/services/feeds/photos_public.gne");

		public async Task DoWorkAsync(ObservableCollection<FlickrImage> images)
		{
			WebClient wc = new WebClient();
			string str = await wc.DownloadStringTaskAsync(FlickrRss);
			StringReader sr = new StringReader(str);
			XmlReader reader = XmlReader.Create(sr);
			SyndicationFeed feed = SyndicationFeed.Load(reader);

			foreach (SyndicationItem item in feed.Items)
			{
				Uri uri = (from link in item.Links where link.RelationshipType == "enclosure" select link.Uri).FirstOrDefault();

				byte[] data = await new WebClient().DownloadDataTaskAsync(uri);

				MemoryStream ms = new MemoryStream(data);
				BitmapImage bi = new BitmapImage();

				bi.BeginInit();
				bi.StreamSource = ms;
				bi.EndInit();

				FlickrImage fi = new FlickrImage();
				fi.Image = bi;
				fi.Title = item.Title.Text;
				images.Add(fi);
			}
		}

		public void Cancel()
		{
		}
	}
}
